// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.



public extension Bot {

    /// Parameters container struct for `getChatMember` method
    struct GetChatMemberParams: JSONEncodable {

        /// Unique identifier for the target chat or username of the target supergroup or channel (in the format @channelusername)
        var chatId: ChatId

        /// Unique identifier of the target user
        var userId: Int64

        /// Custom keys for coding/decoding `GetChatMemberParams` struct
        enum CodingKeys: String, CodingKey {
            case chatId = "chat_id"
            case userId = "user_id"
        }

        public init(chatId: ChatId, userId: Int64) {
            self.chatId = chatId
            self.userId = userId
        }
    }

    /**
     Use this method to get information about a member of a chat. Returns a ChatMember object on success.

     SeeAlso Telegram Bot API Reference:
     [GetChatMemberParams](https://core.telegram.org/bots/api#getchatmember)
     
     - Parameters:
         - params: Parameters container, see `GetChatMemberParams` struct
     - Throws: Throws on errors
     - Returns: Future of `ChatMember` type
     */
    @discardableResult
    func getChatMember(params: GetChatMemberParams) throws -> Future<ChatMember> {
        let body = try httpBody(for: params)
        let headers = httpHeaders(for: params)
        return try client
            .request(endpoint: "getChatMember", body: body, headers: headers)
            .flatMapThrowing { (container) -> ChatMember in
                return try self.processContainer(container)
        }
    }
}
