// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/**
 Represents a link to an animated GIF file. By default, this animated GIF file will be sent by the user with optional caption. Alternatively, you can use input_message_content to send a message with the specified content instead of the animation.

 SeeAlso Telegram Bot API Reference:
 [InlineQueryResultGif](https://core.telegram.org/bots/api#inlinequeryresultgif)
 */
public final class InlineQueryResultGif: Codable {

    /// Custom keys for coding/decoding `InlineQueryResultGif` struct
    enum CodingKeys: String, CodingKey {
        case type = "type"
        case id = "id"
        case gifUrl = "gif_url"
        case gifWidth = "gif_width"
        case gifHeight = "gif_height"
        case gifDuration = "gif_duration"
        case thumbUrl = "thumb_url"
        case title = "title"
        case caption = "caption"
        case parseMode = "parse_mode"
        case replyMarkup = "reply_markup"
        case inputMessageContent = "input_message_content"
    }

    /// Type of the result, must be gif
    public var type: String

    /// Unique identifier for this result, 1-64 bytes
    public var id: String

    /// A valid URL for the GIF file. File size must not exceed 1MB
    public var gifUrl: String

    /// Optional. Width of the GIF
    public var gifWidth: Int?

    /// Optional. Height of the GIF
    public var gifHeight: Int?

    /// Optional. Duration of the GIF
    public var gifDuration: Int?

    /// URL of the static thumbnail for the result (jpeg or gif)
    public var thumbUrl: String

    /// Optional. Title for the result
    public var title: String?

    /// Optional. Caption of the GIF file to be sent, 0-1024 characters
    public var caption: String?

    /// Optional. Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in the media caption.
    public var parseMode: String?

    /// Optional. Inline keyboard attached to the message
    public var replyMarkup: InlineKeyboardMarkup?

    /// Optional. Content of the message to be sent instead of the GIF animation
    public var inputMessageContent: InputMessageContent?


    public init (type: String, id: String, gifUrl: String, gifWidth: Int? = nil, gifHeight: Int? = nil, gifDuration: Int? = nil, thumbUrl: String, title: String? = nil, caption: String? = nil, parseMode: String? = nil, replyMarkup: InlineKeyboardMarkup? = nil, inputMessageContent: InputMessageContent? = nil) {
        self.type = type
        self.id = id
        self.gifUrl = gifUrl
        self.gifWidth = gifWidth
        self.gifHeight = gifHeight
        self.gifDuration = gifDuration
        self.thumbUrl = thumbUrl
        self.title = title
        self.caption = caption
        self.parseMode = parseMode
        self.replyMarkup = replyMarkup
        self.inputMessageContent = inputMessageContent
    }
}
